#!/usr/bin/env python
# -*- coding: UTF8 -*-
import os, sys

try:
	import cPickle
except:
	print "cpickle not found"
	sys.exit(1)

try:
	import gtk
	import gtk.glade
	import gobject
	import osso
	import hildon
  	import datetime
  	import xmlrpclib
	import base64
	import time
	from xml.dom import minidom
except:
	sys.exit(1)

try:
	import wordpresslib
except:
	print "wordpresslib required"
	sys.exit(1)

#try:
#	import htmltextview
#except:
#	print "htmltextview required"
#	sys.exit(1)

import thread
osso_c = osso.Context("maemo_wordpy", "0.5", False)
#osso_hlp = osso.Help(osso_c)
# Columns for ListStore for Categories
(COLUMN_FIXED, COLUMN_DESCRIPTION) = range(2)
(COLUMN_ARTICLE_FIXED, COLUMN_ARTICLE, COLUMN_ID) = range(3)
# Create lists
data=[]
cats=[]
idfromcat=[]
data_articles=[]
del_articles=[]

FILE_EXT = "wpx"

MAIN_TAG = 0
POST_TAG = 1
TITLE_TAG = 2
TEXT_TAG = 3
EXCERPT_TAG = 4
EXTENDED_ENTRY_TAG = 5
TTAGS_TAG = 6	
TRACKS_TAG = 7
SETTINGS_TAG = 8
URL_TAG = 9
USERNAME_TAG = 10
PASSWORD_TAG = 11

if os.path.exists("/usr/share/maemo-wordpy/maemo-wordpy.glade"):
	glade_file = "/usr/share/maemo-wordpy/maemo-wordpy.glade"
else: 
	glade_file = "maemo-wordpy.glade"
	

gtk.gdk.threads_init()

class Wordpy(hildon.Program):


	_xml_tags = {
			MAIN_TAG : "WordPy"
			, POST_TAG : "Post"
			, TITLE_TAG : "Title"
			, TEXT_TAG : "Text"
			, EXCERPT_TAG : "Excerpt"
			, EXTENDED_ENTRY_TAG : "Entry"
			, TTAGS_TAG : "TechnoratiTags"
			, TRACKS_TAG : "Trackbacks"
			, URL_TAG : "URL"
			, SETTINGS_TAG : "Settings"
			, USERNAME_TAG : "Username"
			, PASSWORD_TAG : "Password"
	}

	def __init__(self):
		self.program = hildon.Program()
		self.program.__init__()
		#Create the main window

		self.wndMain = hildon.Window()
		self.wndMain.set_default_size(800, 480)
		self.program.add_window(self.wndMain)
		self.wndMain.connect("key-press-event", self.on_key_press)
		self.wndMain.connect("window-state-event", self.on_window_state_change)
		self.wndMain.connect("destroy", self.quit)
		self.window_in_fullscreen = False
		self.preserve_aspect = True
		self.ignore_preserve_aspect_callback = False
		self.currimg_pixbuf_original = None
			
		self.wTree=gtk.glade.XML(glade_file)
		self.vbox1 = self.wTree.get_widget("vbox1")
		self.vbox1.reparent(self.wndMain)

# Get settings
		self.dat_file = os.path.join(sys.path[0], "/home/user/.maemowordpy/blog.dat")
		self.BlogSettings = WordPressBlogSettings(self.dat_file)

## Create menu  
        #get menu from glade and reparent as common menu in hildon program
		self.mainMenu = self.wTree.get_widget("menubar1")
		menu = gtk.Menu()
		for child in self.mainMenu.get_children():
			child.reparent(menu)
		self.wndMain.set_menu(menu)
		self.mainMenu.destroy()
		
## Set signals for menuitems
# Submenu File
		imgdir = "/usr/share/maemo-wordpy/pixmaps/"
		self.newmenu = self.wTree.get_widget("menuitem3")
		newmenu_img = gtk.Image()
		newmenu_img.set_from_file(imgdir + "gtk-new.png")
		#newmenu_img.set_from_stock(gtk.STOCK_NEW, gtk.ICON_SIZE_DIALOG)
		self.newmenu.set_image(newmenu_img)
		self.newmenu.connect("activate",self.on_file_new)

		self.openmenu = self.wTree.get_widget("menuitem6")
		openmenu_img = gtk.Image()
		openmenu_img.set_from_file(imgdir + "gtk-open.png")
		#openmenu_img.set_from_stock(gtk.STOCK_OPEN, gtk.ICON_SIZE_DIALOG)
		self.openmenu.set_image(openmenu_img)		
		self.openmenu.connect("activate",self.on_file_open)

		self.savemenu = self.wTree.get_widget("menuitem7")
		savemenu_img = gtk.Image()
		savemenu_img.set_from_file(imgdir + "gtk-save.png")
		#savemenu_img.set_from_stock(gtk.STOCK_SAVE, gtk.ICON_SIZE_DIALOG)
		self.savemenu.set_image(savemenu_img)		
		self.savemenu.connect("activate",self.on_file_save)
		
		self.saveasmenu = self.wTree.get_widget("menuitem8")
		saveasmenu_img = gtk.Image()
		saveasmenu_img.set_from_file(imgdir + "gtk-saveas.png")
		#saveasmenu_img.set_from_stock(gtk.STOCK_SAVE_AS, gtk.ICON_SIZE_DIALOG)
		self.saveasmenu.set_image(saveasmenu_img)		
		self.saveasmenu.connect("activate",self.on_file_save_as)		
		
		self.menu_exit = self.wTree.get_widget("menuitem10")
		quitmenu_img = gtk.Image()
		quitmenu_img.set_from_file(imgdir + "gtk-quit.png")
		#quitmenu_img.set_from_stock(gtk.STOCK_QUIT, gtk.ICON_SIZE_DIALOG)
		self.menu_exit.set_image(quitmenu_img)				
		self.menu_exit.connect("activate", self.quit)

# Submenu Edit
		self.cutmenu = self.wTree.get_widget("menuitem13")
		cutmenu_img = gtk.Image()
		cutmenu_img.set_from_file(imgdir + "gtk-cut.png")
		self.cutmenu.set_image(cutmenu_img)			
		self.cutmenu.connect("activate",self.on_cut)

		self.copymenu = self.wTree.get_widget("menuitem12")
		copymenu_img = gtk.Image()
		copymenu_img.set_from_file(imgdir + "gtk-copy.png")
		self.copymenu.set_image(copymenu_img)			
		self.copymenu.connect("activate",self.on_copy)

		self.pastemenu = self.wTree.get_widget("menuitem11")
		pastemenu_img = gtk.Image()
		pastemenu_img.set_from_file(imgdir + "gtk-paste.png")
		self.pastemenu.set_image(pastemenu_img)			
		self.pastemenu.connect("activate",self.on_paste)	
		
		self.toolbarmenu = self.wTree.get_widget("menuitem9")
		self.toolbarmenu.connect("toggled", self.on_view_toolbar)

#Submenu posting	
		self.menu_settings = self.wTree.get_widget("menuitem16")
		settingsmenu_img = gtk.Image()
		settingsmenu_img.set_from_file(imgdir + "gtk-preferences.png")
		self.menu_settings.set_image(settingsmenu_img)			
		self.menu_settings.connect("activate",self.on_btnSettings_clicked)
		
		self.menu_delete = self.wTree.get_widget("menuitem19")
		delmenu_img = gtk.Image()
		delmenu_img.set_from_file(imgdir + "gtk-delete.png")
		self.menu_delete.set_image(delmenu_img)		
		self.menu_delete.connect("activate",self.on_btngetarticles_clicked)
		
		self.menu_categories = self.wTree.get_widget("menuitem17")
		catmenu_img = gtk.Image()
		catmenu_img.set_from_file(imgdir + "gtk-index.png")
		self.menu_categories.set_image(catmenu_img)		
		self.menu_categories.connect("activate",self.on_btncategories_clicked)

		self.menu_post = self.wTree.get_widget("menuitem18")
		postmenu_img = gtk.Image()
		postmenu_img.set_from_file(imgdir + "gtk-up.png")
		self.menu_post.set_image(postmenu_img)		
		self.menu_post.connect("activate",self.on_btnpost_clicked)

#Submenu about
		#self.menu_info = self.wTree.get_widget("menuitem15")
		#infomenu_img = gtk.Image()
		#infomenu_img.set_from_file(imgdir + "gtk-help.png")
		#self.menu_info.set_image(infomenu_img)		
		#self.menu_info.connect("activate",self.on_about_info, osso_hlp)

		self.menu_credits = self.wTree.get_widget("menuitem14")
		creditsmenu_img = gtk.Image()
		creditsmenu_img.set_from_file(imgdir + "gtk-about.png")
		self.menu_credits.set_image(creditsmenu_img)		
		self.menu_credits.connect("activate",self.on_about_credits)
		
## Create toolbar
		self.create_toolbar()
		
## Get glade widgets
		self.txtPost = self.wTree.get_widget("txtPost")
		self.enTitle = self.wTree.get_widget("enTitle")
		self.en_track = self.wTree.get_widget("en_track")
		self.en_tags = self.wTree.get_widget("en_tags")
		self.comm_button = self.wTree.get_widget("comm_button")
		self.pub_button = self.wTree.get_widget("pub_button")
		self.txtPostExt = self.wTree.get_widget("txtPostExt")
		self.txtPostExc = self.wTree.get_widget("txtPostExc")

		#Get the buffer associated with the text views
		self.txtBuffer = self.txtPost.get_buffer()
		self.txtBufferExt = self.txtPostExt.get_buffer()
		self.txtBufferExc = self.txtPostExc.get_buffer()

		#initialize to new
		self.on_file_new(None)

		#Create page for Preview
#		self.vbox4 = gtk.VBox(False, 0)
#		self.vbox4.show()
#		self.vbox4.set_spacing(0)

#		self.htmlview = htmltextview.HtmlTextView()

#		def url_cb(view, url, type_):
#        print "url-clicked", url, type_

#		self.htmlview.connect("url-clicked", url_cb)

#		self.sw = gtk.ScrolledWindow()
#		self.sw.set_property("hscrollbar-policy", gtk.POLICY_AUTOMATIC)
#		self.sw.set_property("vscrollbar-policy", gtk.POLICY_AUTOMATIC)
#		self.sw.set_property("border-width", 0)
#		self.sw.add(self.htmlview)
#		self.sw.show()

#		self.frame = gtk.Frame()
#		self.frame.set_shadow_type(gtk.SHADOW_IN)
#		self.frame.show()
#		self.frame.add(self.sw)

#		self.vbox4.pack_start(self.frame, True, True, 0)

		#Add page4 to notebook
#		self.page4 = gtk.Label("<small>Preview</small>")
#		self.page4.set_padding(0, 0)
#		self.page4.set_use_markup(True)
#		self.page4.show()

#		self.notebook.append_page(self.vbox4, self.page4)
#		self.notebook.connect("switch_page", self.html_view)
#		pagenum = self.notebook.get_current_page()


        #destroy the gtk window imported from glade
		self.gtkWindow = self.wTree.get_widget("window1")
		self.gtkWindow.destroy()
		
		self.wndMain.show_all()
		
#	def html_view(self, widget, dummy, pagenum):
#		if pagenum == 3:
#			iter_start = self.txtBuffer.get_start_iter()
#			iter_end = self.txtBuffer.get_end_iter()
#			text_main = self.txtBuffer.get_text(iter_start, iter_end, include_hidden_chars=1)

#			self.htmlview.delete_html()
#			self.htmlview.display_html("""
#    <body xmlns='http://www.w3.org/1999/xhtml'>
#        """ + text_main + """
#    </body>
#		""")
#			self.htmlview.show()
#		else: 'Error in HtmlView.'

	#Functions for fullscreen
	def on_window_state_change(self, widget, event, *args):           
		if event.new_window_state & gtk.gdk.WINDOW_STATE_FULLSCREEN:
			self.window_in_fullscreen = True
		else:
			self.window_in_fullscreen = False

	def on_key_press(self, widget, event, *args):            
		if event.keyval == gtk.keysyms.F6:
			if self.window_in_fullscreen:
				self.wndMain.unfullscreen ()
			else:
				self.wndMain.fullscreen ()

	def create_toolbar(self):
		self.toolbar = gtk.Toolbar()

		bold_img = gtk.Image()
		bold = gtk.ToolButton(bold_img, None)
		bold.set_expand(True)
		bold.connect("clicked", self.on_btnBold_clicked)
		self.toolbar.insert(bold, -1)
		
		italic_img = gtk.Image()
		italic = gtk.ToolButton(italic_img, None)
		italic.set_expand(True)
		italic.connect("clicked", self.on_btnItalic_clicked)		
		self.toolbar.insert(italic, -1)
		
		link_img = gtk.Image()
		link = gtk.ToolButton(link_img, None)
		link.set_expand(True)
		link.connect("clicked", self.on_btnLink_clicked)		
		self.toolbar.insert(link, -1)

		quote_img = gtk.Image()
		quote = gtk.ToolButton(quote_img, None)
		quote.set_expand(True)
		quote.connect("clicked", self.on_btnBlockQuote_clicked)		
		self.toolbar.insert(quote, -1)

		under_img = gtk.Image()
		underline = gtk.ToolButton(under_img, None)
		underline.set_expand(True)
		underline.connect("clicked", self.on_btnIns_clicked)
		self.toolbar.insert(underline, -1)
		
		strike_img = gtk.Image()
		strikethrough = gtk.ToolButton(strike_img, None)
		strikethrough.set_expand(True)
		strikethrough.connect("clicked", self.on_btnDel_clicked)
		self.toolbar.insert(strikethrough, -1)
		
		imgsrc_img = gtk.Image()
		image = gtk.ToolButton(imgsrc_img, None)
		image.set_expand(True)
		image.connect("clicked", self.on_btnImage_clicked)		
		self.toolbar.insert(image, -1)
		
		parag_img = gtk.Image()
		parag = gtk.ToolButton(parag_img, None)
		parag.set_expand(True)
		parag.connect("clicked", self.on_btnparag_clicked)
		self.toolbar.insert(parag, -1)
		
		##RENEGOCIAR ESTO DE OTRA MANERA
		
		if os.path.exists("/usr/share/maemo-wordpy/pixmaps/"):
			bold_img.set_from_file("/usr/share/maemo-wordpy/pixmaps/bold.png")
			italic_img.set_from_file("/usr/share/maemo-wordpy/pixmaps/italic.png")
			link_img.set_from_file("/usr/share/maemo-wordpy/pixmaps/link.png")
			quote_img.set_from_file("/usr/share/maemo-wordpy/pixmaps/quote.png")
			under_img.set_from_file("/usr/share/maemo-wordpy/pixmaps/underline.png")
			strike_img.set_from_file("/usr/share/maemo-wordpy/pixmaps/strikethrough.png")
			imgsrc_img.set_from_file("/usr/share/maemo-wordpy/pixmaps/image.png")
			parag_img.set_from_file("/usr/share/maemo-wordpy/pixmaps/paragraph.png")
		else: 
			bold_img.set_from_file("pixmaps/bold.png")
			italic_img.set_from_file("pixmaps/italic.png")
			link_img.set_from_file("pixmaps/link.png")
			quote_img.set_from_file("pixmaps/quote.png")
			under_img.set_from_file("pixmaps/underline.png")
			strike_img.set_from_file("pixmaps/strikethrough.png")
			imgsrc_img.set_from_file("pixmaps/image.png")
			parag_img.set_from_file("pixmaps/paragraph.png")
				
		more = gtk.ToolButton(gtk.STOCK_ADD)
		more.set_expand(True)
		more.connect("clicked", self.on_optwrite_clicked)
		self.toolbar.insert(more, -1)
		
		settings = gtk.ToolButton(gtk.STOCK_PREFERENCES)
		settings.set_expand(True)
		settings.connect("clicked", self.on_btnSettings_clicked)
		self.toolbar.insert(settings, -1)		
		
		delete_art = gtk.ToolButton(gtk.STOCK_DELETE)
		delete_art.set_expand(True)
		delete_art.connect("clicked", self.on_btngetarticles_clicked)
		self.toolbar.insert(delete_art, -1)			
		
		categories = gtk.ToolButton(gtk.STOCK_INDEX)
		categories.set_expand(True)
		categories.connect("clicked", self.on_btncategories_clicked)
		self.toolbar.insert(categories, -1)

		post = gtk.ToolButton(gtk.STOCK_GO_UP)
		post.set_expand(True)
		post.connect("clicked", self.on_btnpost_clicked)
		self.toolbar.insert(post, -1)

		self.wndMain.add_toolbar(self.toolbar)

	def on_view_toolbar(self, widget):
		if self.toolbarmenu.get_active() == False:
			self.toolbar.destroy()
			self.wndMain.show_all()
		else:
			self.create_toolbar()
			self.wndMain.show_all()

	def quit(self, widget):
		"""Quit yourself"""
		self.BlogSettings.save(self.dat_file)
		gtk.main_quit()


	def on_file_new(self, widget):
		self.enTitle.set_text("")
		self.set_post_text("")
		self.xml_file = None
		self.en_tags.set_text("")
		self.en_track.set_text("")

		#Clear the Extended Entry
		self.txtBufferExt.delete(self.txtBufferExt.get_start_iter(), self.txtBufferExt.get_end_iter())
		#Clear the Excerpt
		self.txtBufferExc.delete(self.txtBufferExc.get_start_iter(), self.txtBufferExc.get_end_iter())


	def on_file_open(self, widget):
		"""This function open an XML file"""
		xml_file = self.file_browse(gtk.FILE_CHOOSER_ACTION_OPEN)
		if (xml_file == False) or (xml_file== None):
			self.xml_file = self.xml_file
			print self.xml_file
			print 'No file selected.'
			return			

		self.xml_load_from_file(xml_file)
		self.xml_file = xml_file

	def on_file_save(self, widget):
		"""This function saves the current post as an XML file"""

		# Let the user browse for the save location and name
		if (self.xml_file == None) or (self.xml_file == False):
			self.xml_file = self.file_browse(gtk.FILE_CHOOSER_ACTION_SAVE)
		#If we have a xml_file
		if (self.xml_file):
			self.xml_save_to_file(self.xml_file)

	def xml_save_to_file(self, xml_file):
		"""Save the current post to xml_file
		@param xml_file - string - path to file that
		we will save the xml to.
		@returns boolean - True success. False failure
		"""
		#Init return value
		success = False

		#Get the available DOM Implementation
		impl = minidom.getDOMImplementation()
		#Create the document, with wordpy as to base node
		xml_document = impl.createDocument(None, self._xml_tags[MAIN_TAG], None)
		#Save the post settings into the xml
		self.xml_save(xml_document)
		#Save the Blog settings into the XML
		self.BlogSettings.xml_save(xml_document)
		#Now actually try to save the file
		try:
			save_file = open(xml_file, 'w')
			#write the xml document to disc
			xml_document.documentElement.writexml(save_file)
			save_file.close()
		except IOError, (errno, strerror):
			self.show_error_dlg(
				"Error saving post(%s): %s" % (errno, strerror))
		else:
			#Allright it all worked! Set the return value
			success = True

		return success

	def xml_load_from_file(self, xml_file):
		"""Load a post from an xml file
		@param xml_file - string - path to file that
		we will load.
		@returns boolean - True success. False failure
		"""
		#Init return value
		success = False

		#Load the xml_file to a document
		try:
			xml_document = minidom.parse(xml_file)
			if (xml_document):
				success = ((self.xml_load(xml_document))
						and (self.BlogSettings.xml_load(xml_document)))
		except IOError, (errno, strerror):
			self.show_error_dlg(
				"Error loading post file(%s): %s" % (errno, strerror))
		except:
			self.show_error_dlg("Error loading post file.")
		return success


	def on_file_save_as(self, widget):
		"""Let the user save the current file to a new location."""

		xml_file = "Untitled"
		if (self.xml_file != None) and (self.xml_file != False):
			xml_file = os.path.basename(self.xml_file)

		xml_file = self.file_browse(gtk.FILE_CHOOSER_ACTION_SAVE, xml_file)
		#If we have a xml_file
		if (xml_file):
			if (self.xml_save_to_file(xml_file)):
				"""Allright it all worked! save the current file and
				set the title."""
				self.xml_file = xml_file


	def xml_save(self, xml_document):
		"""Save the current blog post to an xml document.
		@param xml_document - xml.dom.minidom.Document object -
		The xml document that we will save the post to."""

		#First create the "post" xml element
		post_element = xml_document.createElement(self._xml_tags[POST_TAG])  # creates <post></post>
		#Title
		title = self.enTitle.get_text()
		#Text
		start, end = self.txtBuffer.get_bounds()
		text = self.txtBuffer.get_text(start, end)
		extended_text = self.txtBufferExt.get_text(self.txtBufferExt.get_start_iter(), self.txtBufferExt.get_end_iter(), include_hidden_chars=1)
		excerpt = self.txtBufferExc.get_text(self.txtBufferExc.get_start_iter(), self.txtBufferExc.get_end_iter(), include_hidden_chars=1)
		ttags_text = self.en_tags.get_text()
		tracks_text = self.en_track.get_text()
		# creates <title></title>
		title_element = xml_document.createElement(self._xml_tags[TITLE_TAG])
		#Create <title>title text</title>
		title_element.appendChild(xml_document.createTextNode(title))
		# creates <text></text>
		text_element = xml_document.createElement(self._xml_tags[TEXT_TAG])
		# creates <text>text</text>
		text_element.appendChild(xml_document.createTextNode(text))
		#create excerpt
		excerpt_element = xml_document.createElement(self._xml_tags[EXCERPT_TAG])
		# creates <excerpt>excerpt text</excerpt>
		excerpt_element.appendChild(xml_document.createTextNode(excerpt))		
		#create extended entry
		extended_element = xml_document.createElement(self._xml_tags[EXTENDED_ENTRY_TAG])
		# creates <extended>extended text</extended>
		extended_element.appendChild(xml_document.createTextNode(extended_text))	
		#create ttags
		ttags_element = xml_document.createElement(self._xml_tags[TTAGS_TAG])		
		# creates <ttags>technorati tags</ttags>
		ttags_element.appendChild(xml_document.createTextNode(ttags_text))		
		#create trackbacks
		tracks_element = xml_document.createElement(self._xml_tags[TRACKS_TAG])		
		# creates <trackbacks>trackbacks</trackbacks>
		tracks_element.appendChild(xml_document.createTextNode(tracks_text))		
		
		#Now create <post><title>title text</title><text>text</text></post>
		post_element.appendChild(title_element)
		post_element.appendChild(text_element)
		post_element.appendChild(excerpt_element)
		post_element.appendChild(extended_element)		
		post_element.appendChild(ttags_element)
		post_element.appendChild(tracks_element)		
		
		#Now add to the xml docuemnt
		xml_document.documentElement.appendChild(post_element)

	def xml_load(self, xml_document):
		"""Load the current blog post from an xml document.
		@param xml_document - xml.dom.minidom.Document object -
		The xml document that we will load the post from.
		@returns boolean True - success.  False - Failure."""

		title_loaded = False
		text_loaded = False
		excerpt_loaded = False
		extended_loaded = False
		ttags_loaded = False
		tracks_loaded = False

		#Loop through all child nodes of the root.
		for node in xml_document.documentElement.childNodes:
			#We are looking for the post Node
			if (node.nodeName == self._xml_tags[POST_TAG]):
				# Now loop through the post nodes children
				for item_node in node.childNodes:
					if (item_node.nodeName == self._xml_tags[TITLE_TAG]):
						"""Set the title, the firstChild in this case is
						the actual title text that we saved."""

						#Make sure it's not a blank string
						if (item_node.firstChild):
							self.enTitle.set_text(item_node.firstChild.nodeValue)
						else:
							self.enTitle.set_text("")
						title_loaded = True
					elif (item_node.nodeName == self._xml_tags[TEXT_TAG]):
						"""Set the text, the firstChild in this case is
						the actual text that we saved."""
						#Make sure it's not a blank string
						if (item_node.firstChild):
							self.set_post_text(item_node.firstChild.nodeValue)
						else:
							self.set_post_text("")
						text_loaded = True
					elif (item_node.nodeName == self._xml_tags[EXCERPT_TAG]):
						"""Set the text, the firstChild in this case is
						the actual text that we saved."""
						#Make sure it's not a blank string
						if (item_node.firstChild):
							self.txtBufferExc.set_text(item_node.firstChild.nodeValue)
						else:
							self.txtBufferExc.set_text("")
						excerpt_loaded = True						
					elif (item_node.nodeName == self._xml_tags[EXTENDED_ENTRY_TAG]):
						"""Set the text, the firstChild in this case is
						the actual text that we saved."""
						#Make sure it's not a blank string
						if (item_node.firstChild):
							self.txtBufferExt.set_text(item_node.firstChild.nodeValue)
						else:
							self.txtBufferExt.set_text("")
						extended_loaded = True													
					elif (item_node.nodeName == self._xml_tags[TTAGS_TAG]):
						"""Set the text, the firstChild in this case is
						the actual text that we saved."""
						#Make sure it's not a blank string
						if (item_node.firstChild):
							self.en_tags.set_text(item_node.firstChild.nodeValue)
						else:
							self.en_tags.set_text("")
						ttags_loaded = True							
					elif (item_node.nodeName == self._xml_tags[TRACKS_TAG]):
						"""Set the text, the firstChild in this case is
						the actual text that we saved."""
						#Make sure it's not a blank string
						if (item_node.firstChild):
							self.en_track.set_text(item_node.firstChild.nodeValue)
						else:
							self.en_track.set_text("")
						tracks_loaded = True							
	
				#Break out of the topmost for loop
				break

		return (title_loaded and text_loaded and excerpt_loaded and extended_loaded and ttags_loaded and tracks_loaded)

	def set_post_text(self, text):
		"""Simple Helper function that sets the text
		in the text View.
		@param text - The text that will be put into
		the text view.
		"""
		#select all of the text
		start, end = self.txtBuffer.get_bounds()
		self.txtBuffer.select_range(end,start)
		#insert over the selection i.e. replace all the text
		self.insert_text(text)
		#put the selection at the end.
		start, end = self.txtBuffer.get_bounds()
		self.txtBuffer.select_range(end,end)


	# Borrowed from the PyWine project and modified for Maemo WordPy
	def file_browse(self, dialog_action, file_name=""):
		"""This function is used to browse for a file.
		It can be either a save or open dialog depending on
		what dialog_action is.
		The path to the file will be returned if the user
		selects one, however a blank string will be returned
		if they cancel or do not select one.
		dialog_action - The open or save mode for the dialog either
		gtk.FILE_CHOOSER_ACTION_OPEN, gtk.FILE_CHOOSER_ACTION_SAVE
		@param file_name - Default name when doing a save
		@returns - File Name, or None on cancel.
		"""

		if (dialog_action==gtk.FILE_CHOOSER_ACTION_OPEN):
			dlg_title = "Open Article"
		else:
			dlg_title = "Save Article"

		file_dialog = hildon.FileChooserDialog(self.wndMain, action=dialog_action)
		file_dialog.set_title(dlg_title)
		file_dialog.set_default_response(gtk.RESPONSE_CANCEL)
		"""set the filename if we are saving"""
		if (dialog_action==gtk.FILE_CHOOSER_ACTION_SAVE):
			file_dialog.set_current_name(file_name)
			file_dialog.set_current_folder('/home/user/MyDocs/.documents')
		"""Init the return value"""
		result = file_dialog.run()
		if result == gtk.RESPONSE_OK:
			namefile = file_dialog.get_filename()
			if (dialog_action==gtk.FILE_CHOOSER_ACTION_SAVE):
				namefile, extension = os.path.splitext(namefile)
				namefile = namefile + "." + FILE_EXT
		else:
			namefile = False
		file_dialog.destroy()

		return namefile


	def on_cut(self, widget):
		if self.txtPost.is_focus() == 1:
			self.txtPost.emit("cut-clipboard")
		elif self.enTitle.is_focus() == 1:
			self.enTitle.emit("cut-clipboard")
		elif self.en_track.is_focus() == 1:
			self.en_track.emit("cut-clipboard")
		elif self.en_tags.is_focus() == 1:
			self.en_tags.emit("cut-clipboard")
		elif self.txtPostExt.is_focus() == 1:
			self.txtPostExt.emit("cut-clipboard")
		elif self.txtPostExc.is_focus() == 1:
			self.txtPostExc.emit("cut-clipboard")		
		else:
			pass

	def on_copy(self, widget):
		if self.txtPost.is_focus() == 1:
			self.txtPost.emit("copy-clipboard")
		elif self.enTitle.is_focus() == 1:
			self.enTitle.emit("copy-clipboard")
		elif self.en_track.is_focus() == 1:
			self.en_track.emit("copy-clipboard")
		elif self.en_tags.is_focus() == 1:
			self.en_tags.emit("copy-clipboard")
		elif self.txtPostExt.is_focus() == 1:
			self.txtPostExt.emit("copy-clipboard")
		elif self.txtPostExc.is_focus() == 1:
			self.txtPostExc.emit("copy-clipboard")		
		else:
			pass

	def on_paste(self, widget):
		if self.txtPost.is_focus() == 1:
			self.txtPost.emit("paste-clipboard")
		elif self.enTitle.is_focus() == 1:
			self.enTitle.emit("paste-clipboard")
		elif self.en_track.is_focus() == 1:
			self.en_track.emit("paste-clipboard")
		elif self.en_tags.is_focus() == 1:
			self.en_tags.emit("paste-clipboard")
		elif self.txtPostExt.is_focus() == 1:
			self.txtPostExt.emit("paste-clipboard")
		elif self.txtPostExc.is_focus() == 1:
			self.txtPostExc.emit("paste-clipboard")
		#lost focus for text here:
#		if self.enURL.is_focus() == 1:
#			self.enURL.emit("paste-clipboard")				
		else:
			pass

	def on_about_credits(self, widget):
		"""Show the credits dialog."""
		dialog = gtk.AboutDialog()
		dialog.set_name("Maemo WordPy")
		dialog.set_version("0.5")
		dialog.set_copyright("Copyright © 2007")
		dialog.set_website("http://maemo-wordpy.garage.maemo.org")
		dialog.set_authors(["Daniel Martín Yerga <dyerga@gmail.com> \n\nBased in WordPy by Mark Mruss"])
 		logo = gtk.gdk.pixbuf_new_from_file("/usr/share/maemo-wordpy/pixmaps/logo.png")
		dialog.set_logo(logo)
		dialog.set_license("This program is released under the GNU\nGeneral Public License. Please visit \nhttp://www.gnu.org/copyleft/gpl.html\nfor details.")
		dialog.set_artists(["Logo by Daniel Martín Yerga.\nMenu icons from Gartoon Iconset. GPL License."])

		dialog.run()
		dialog.destroy()

	#def on_about_info(self, widget, osso_hlp):
		#osso_hlp.show("help_maemowordpy_started", 1)

	def show_error_dlg(self, error_string):
		"""This Function is used to show an error dialog when
		an error occurs.
		error_string - The error string that will be displayed
		on the dialog.
		"""
		error_dlg = gtk.MessageDialog(type=gtk.MESSAGE_ERROR, message_format=error_string, buttons=gtk.BUTTONS_OK)
		error_dlg.run()
		error_dlg.destroy()

	def on_btnBold_clicked(self, widget):
		"""Called when the bold button is clicked"""
		self.wrap_selection("<span style='font-weight: bold'>","</span>")

	def on_btnItalic_clicked(self, widget):
		"""Called when the italic button is clicked"""
		self.wrap_selection("<span style='font-style: italic'>","</span>")

	def on_btnLink_clicked(self, widget):
		"""Called when the link button is clicked"""				
		self.wTree=gtk.glade.XML(glade_file)
		link_dlg = self.wTree.get_widget("main_dialog")
		link_dlg.set_title("Insert Link")
		link_dlg.set_default_response(gtk.RESPONSE_CANCEL)
	
		self.enURL = self.wTree.get_widget("main_entry")
		self.enURL.set_text("http://")
		self.enURL.select_region(7, 7)
		link_label = self.wTree.get_widget("main_label")
		link_label.set_text("Enter the URL:")
		
		def on_ok_clicked(widget):
			start, end = self.get_selection_iters()
			if ((start)and(end)):
				self.txtBuffer.select_range(end,start)
			self.wrap_selection("<a href=\"%s\">" % self.enURL.get_text(),"</a>")
			link_dlg.destroy()

		def on_cancel_clicked(widget):
			link_dlg.destroy()
		
		cancel_btn = self.wTree.get_widget("cancelbtn")
		cancel_btn.connect("clicked", on_cancel_clicked)
		ok_btn = self.wTree.get_widget("okbtn")
		ok_btn.connect("clicked", on_ok_clicked)	
			
		result = link_dlg.run()
		link_dlg.destroy()
		
	def on_btnBlockQuote_clicked(self, widget):
		"""Called when the Block Quote button is clicked"""		
		self.wrap_selection("<blockquote>","</blockquote>")

	def on_btnDel_clicked(self, widget):
		"""Called when the Del button is clicked"""
		today = datetime.date.today()
		self.wrap_selection('<span style="text-decoration:line-through">','</span>')

	def on_btnIns_clicked(self, widget):
		"""Called when the Ins button is clicked"""
		today = datetime.date.today()
		self.wrap_selection('<span style="text-decoration:underline">','</span>')

	def on_btnImage_clicked(self, widget):
		"""Called when the Image button is clicked"""

		def on_image_ok_clicked(widget):
			self.imageURL = self.en_imgsrc.get_text()
			self.imageAlt = self.en_alttext.get_text()
			self.imageAlign = self.img_align.get_active_text()
			self.imageHeight = str(self.img_width.get_value_as_int())
			self.imageWidth = str(self.img_height.get_value_as_int()) 

			if self.txtPost.is_focus() == 1:
				self.txtBuffer = self.txtPost.get_buffer()
			elif self.txtPostExt.is_focus() == 1:
				self.txtBuffer = self.txtPostExt.get_buffer()
			elif self.txtPostExc.is_focus() == 1:
				self.txtBuffer = self.txtPostExc.get_buffer()
			
			self.currimg_pixbuf_original = None

			if self.imageURL.find("http://") >= 0:
				pass
			else: 
				#Try to get the wordpress client
				wp = self.BlogSettings.create_wordpress_client()
				if (wp == None):
					#Error creating Client, setting maybe wrong
					self.show_error_dlg("Error creating Wordpress client, please check settings.")
					#Now get out of here
					return

				elif (self.imageURL!=""):
					try: #It will try upload an image file
						#Add interaction with conic library :)
						self.senal = True
						thread.start_new_thread(self.upload_img, (self.imageURL, wp))
						self.pgbar = ProgressBar("Uploading Image", self.wndMain)

						#imageSrc = wp.newMediaObject(self.imageURL)
					except wordpresslib.WordPressException, e:
						self.pgbar.stop_pg()
						#wordpress lib error
						self.show_error_dlg(
						"Error uploading image:\nError code: %s\nError Message: %s"
						% (e.id, e.message))
					except xmlrpclib.Fault, e:
						self.pgbar.stop_pg()
						self.show_error_dlg(
						"Error uploading image:\nError code: %s\nError Message: %s"
						% (e.faultCode, e.faultString))
					except xmlrpclib.ProtocolError, e:
						self.pgbar.stop_pg()
						self.show_error_dlg(
						"Error uploading image:\nURL: %s\nError code: %s\nError Message: %s"
						% (e.url, e.errcode, e.errmsg))

			thread.start_new_thread(self.text_img, ())


		def on_image_cancel_clicked(widget):
			self.image_dlg.destroy()
			self.currimg_pixbuf_original = None
			
			
		self.wTree=gtk.glade.XML(glade_file)
		self.image_dlg = self.wTree.get_widget("img_dlg")
		self.image_dlg.set_title("Insert Image")
		
		img_btn = self.wTree.get_widget("img_btn")
		img_btn.connect("clicked", self.browse_for_image)
		
		self.en_imgsrc = self.wTree.get_widget("en_img")
		self.en_alttext = self.wTree.get_widget("en_alttext")

		self.img_align = self.wTree.get_widget("combo_img_align")

		self.label14 = self.wTree.get_widget("label14")
		self.label15 = self.wTree.get_widget("label15")
		
		self.original_button = self.wTree.get_widget("original")
		self.original_button.set_active(True)
		self.original_button.connect('toggled', self.on_original_active)
		self.resize_button = self.wTree.get_widget("resize")

		self.img_width = self.wTree.get_widget("img_width")

		self.img_height = self.wTree.get_widget("img_height")
		self.img_width.connect('value-changed', self.preserve_image_aspect, "width", self.img_height)
		self.img_height.connect('value-changed', self.preserve_image_aspect, "height", self.img_width)
		
		self.ratio_btn = self.wTree.get_widget("ratio_btn")
		self.ratio_btn.set_active(self.preserve_aspect)
		self.ratio_btn.connect('toggled', self.aspect_ratio_toggled, self.img_width, self.img_height)
		
		self.do_resize_widgets_insensitive()
		
		self.image_cancel_button= self.wTree.get_widget("img_cancel")
		self.image_cancel_button.connect("clicked", on_image_cancel_clicked)
		
		self.image_ok_button= self.wTree.get_widget("img_ok")
		self.image_ok_button.connect("clicked", on_image_ok_clicked)

		result = self.image_dlg.run()
		self.image_dlg.destroy()
		
	def on_original_active(self, widget):
		if self.original_button.get_active() == True:
			self.do_resize_widgets_insensitive()
		else:
			self.img_width.set_sensitive(True)
			self.label14.set_sensitive(True)
			self.label15.set_sensitive(True)
			self.img_height.set_sensitive(True)
			self.ratio_btn.set_sensitive(True)	
				
	def do_resize_widgets_insensitive(self):
		self.img_width.set_sensitive(False)
		self.label14.set_sensitive(False)
		self.label15.set_sensitive(False)
		self.img_height.set_sensitive(False)
		self.ratio_btn.set_sensitive(False)	
		
	def aspect_ratio_toggled(self, togglebutton, width, height):
		try:
			self.preserve_aspect = togglebutton.get_active()
			if self.preserve_aspect:
				# Set height based on width and aspect ratio
				target_value = float(width.get_value_as_int())/self.currimg_pixbuf_original.get_width()
				target_value = int(target_value * self.currimg_pixbuf_original.get_height())
				self.ignore_preserve_aspect_callback = True
				height.set_value(target_value)
				self.ignore_preserve_aspect_callback = False
		except:
			print 'Image not selected.'
	
	def preserve_image_aspect(self, currspinbox, type, otherspinbox):
		try:
			if not self.preserve_aspect:
				return
			if self.ignore_preserve_aspect_callback:
				return
			if type == "width":
				target_value = float(currspinbox.get_value_as_int())/self.currimg_pixbuf_original.get_width()
				target_value = int(target_value * self.currimg_pixbuf_original.get_height())
			else:
				target_value = float(currspinbox.get_value_as_int())/self.currimg_pixbuf_original.get_height()
				target_value = int(target_value * self.currimg_pixbuf_original.get_width())
			self.ignore_preserve_aspect_callback = True
			otherspinbox.set_value(target_value)
			self.ignore_preserve_aspect_callback = False
		except:
			print 'Image not selected.'
		
	def upload_img(self, imgURL, wp):
		self.imageSrc = wp.newMediaObject(imgURL)
		if (self.imageSrc):
			self.imageURL = self.imageSrc
			self.pgbar.stop_pg()
			self.senal = False
		else:
			self.pgbar.stop_pg()
			self.show_error_dlg("Error uploading image.")

	def text_img(self):
		self.image_dlg.destroy()

		if self.imageURL.find("http://") >= 0:
			pass
		else:
			while self.senal:
				time.sleep(0.5)
		img_src = "<img src=\"" + self.imageURL

		#If there is, get options for image (alt, align, etc)
		if self.imageURL == '':
			self.image_dlg.destroy()
			return
		if self.resize_button.get_active() == True:
			img_src = img_src + "\" width=\"" + self.imageWidth + "\" height=\"" + self.imageHeight
		if self.imageAlt != '':
			img_src = img_src + "\" alt=\"" + self.imageAlt
		#final_img_src is the final <img src...> text
		final_img_src = img_src + "\" />"

		if self.imageAlign != '':
			text1 = '<div style="text-align:' +  self.imageAlign + '">'
			self.txtBuffer.insert_at_cursor(text1, -1)
			start, end = self.txtBuffer.get_bounds()
			self.txtBuffer.insert_interactive(end, final_img_src, -1)
			text2 = '</div>'
			start, end = self.txtBuffer.get_bounds()			
			self.txtBuffer.insert_interactive(end, text2, -1)
		else:
			self.txtBuffer.insert_at_cursor(final_img_src, -1)
			
		self.image_dlg.destroy()
		
	def on_btnparag_clicked(self, widget):
		self.wrap_selection("<p>", "</p>")

	def on_optwrite_clicked(self, widget):
		"""Called when the MoreTags button is clicked"""	
		self.wTree=gtk.glade.XML(glade_file)
		self.optwrite_dlg = self.wTree.get_widget("tagsdialog")
		#osso_hlp.dialog_help_enable(self.optwrite_dlg, "help_maemowordpy_tags")
		self.optwrite_dlg.set_default_response(gtk.RESPONSE_CANCEL)
		
		self.btnleft = self.wTree.get_widget("left")
		left_img = gtk.Image()
		self.btnleft.add(left_img)

		self.btnright = self.wTree.get_widget("right")
		right_img = gtk.Image()	
		self.btnright.add(right_img)

		self.btncenter = self.wTree.get_widget("center")
		center_img = gtk.Image()						
		self.btncenter.add(center_img)

		self.btnjustify = self.wTree.get_widget("justify")
		fill_img = gtk.Image()			
		self.btnjustify.add(fill_img)
		
		self.btnMore = self.wTree.get_widget("more")
		more_img = gtk.Image()	
		self.btnMore.add(more_img)

		self.btncode = self.wTree.get_widget("code")
		code_img = gtk.Image()
		self.btncode.add(code_img)
		
		self.btnListItem = self.wTree.get_widget("li")
		li_img = gtk.Image() 
		self.btnListItem.add(li_img)
		
		self.btnUnorderedList  = self.wTree.get_widget("ul")
		ul_img = gtk.Image()
		self.btnUnorderedList.add(ul_img)
		
		self.btnOrderedList = self.wTree.get_widget("ol")
		ol_img = gtk.Image()
		self.btnOrderedList.add(ol_img)
		
		self.btncolor_text = self.wTree.get_widget("color")
		color_img = gtk.Image()
		self.btncolor_text.add(color_img)
		
		self.btnbg_color = self.wTree.get_widget("backg")
		bg_img = gtk.Image()
		self.btnbg_color.add(bg_img)		
		
		self.btnfont_size = self.wTree.get_widget("fontsize")
		fontsize_img = gtk.Image()
		self.btnfont_size.add(fontsize_img)
		
		self.btn_super = self.wTree.get_widget("superscript")
		super_img = gtk.Image()
		self.btn_super.add(super_img)
		
		self.btn_sub = self.wTree.get_widget("subscript")
		sub_img = gtk.Image()
		self.btn_sub.add(sub_img)
		
		self.btn_tt = self.wTree.get_widget("tt")
		tt_img = gtk.Image()
		self.btn_tt.add(tt_img)
		
		self.btn_cite = self.wTree.get_widget("cite")
		cite_img = gtk.Image()
		self.btn_cite.add(cite_img)
		
		self.btn_abbr = self.wTree.get_widget("abbr")
		abbr_img = gtk.Image()
		self.btn_abbr.add(abbr_img)
		
		self.btn_acron = self.wTree.get_widget("acron")	
		acron_img = gtk.Image()
		self.btn_acron.add(acron_img)
		
		
		if os.path.exists("/usr/share/maemo-wordpy/pixmaps/"):
			left_img.set_from_file("/usr/share/maemo-wordpy/pixmaps/left.png")
			right_img.set_from_file("/usr/share/maemo-wordpy/pixmaps/right.png")
			center_img.set_from_file("/usr/share/maemo-wordpy/pixmaps/center.png")
			fill_img.set_from_file("/usr/share/maemo-wordpy/pixmaps/fill.png")
			more_img.set_from_file("/usr/share/maemo-wordpy/pixmaps/more.png")
			code_img.set_from_file("/usr/share/maemo-wordpy/pixmaps/code.png")
			li_img.set_from_file("/usr/share/maemo-wordpy/pixmaps/li.png")
			ul_img.set_from_file("/usr/share/maemo-wordpy/pixmaps/ul.png")
			ol_img.set_from_file("/usr/share/maemo-wordpy/pixmaps/ol.png")
			color_img.set_from_file("/usr/share/maemo-wordpy/pixmaps/font_color.png")
			bg_img.set_from_file("/usr/share/maemo-wordpy/pixmaps/bg_color.png")
			fontsize_img.set_from_file("/usr/share/maemo-wordpy/pixmaps/font_size.png")
			super_img.set_from_file("/usr/share/maemo-wordpy/pixmaps/superscript.png")
			sub_img.set_from_file("/usr/share/maemo-wordpy/pixmaps/subscript.png")
			tt_img.set_from_file("/usr/share/maemo-wordpy/pixmaps/tt.png")
			cite_img.set_from_file("/usr/share/maemo-wordpy/pixmaps/cite.png")
			abbr_img.set_from_file("/usr/share/maemo-wordpy/pixmaps/abbr.png")
			acron_img.set_from_file("/usr/share/maemo-wordpy/pixmaps/acronym.png")
		else:
			left_img.set_from_file("pixmaps/left.png")
			right_img.set_from_file("pixmaps/right.png")
			center_img.set_from_file("pixmaps/center.png")
			fill_img.set_from_file("pixmaps/fill.png")
			more_img.set_from_file("pixmaps/more.png")
			code_img.set_from_file("pixmaps/code.png")
			li_img.set_from_file("pixmaps/li.png")
			ul_img.set_from_file("pixmaps/ul.png")
			ol_img.set_from_file("pixmaps/ol.png")
			color_img.set_from_file("pixmaps/font_color.png")
			bg_img.set_from_file("pixmaps/bg_color.png")
			fontsize_img.set_from_file("pixmaps/font_size.png")
			super_img.set_from_file("pixmaps/superscript.png")
			sub_img.set_from_file("pixmaps/subscript.png")
			tt_img.set_from_file("pixmaps/tt.png")
			cite_img.set_from_file("pixmaps/cite.png")
			abbr_img.set_from_file("pixmaps/abbr.png")
			acron_img.set_from_file("pixmaps/acronym.png")
		
		self.btnleft.connect("clicked", self.on_btnleft_clicked)
		self.btncenter.connect("clicked", self.on_btncenter_clicked)
		self.btnright.connect("clicked", self.on_btnright_clicked)
		self.btnjustify.connect("clicked", self.on_btnjustify_clicked)
		self.btnMore.connect("clicked", self.on_btnMore_clicked)
		self.btncode.connect("clicked", self.on_btnCode_clicked)
		self.btnListItem.connect("clicked", self.on_btnListItem_clicked)
		self.btnUnorderedList.connect("clicked", self.on_btnUnorderedList_clicked)
		self.btnOrderedList.connect("clicked", self.on_btnOrderedList_clicked)
		self.btncolor_text.connect("clicked", self.on_text_color_clicked)
		self.btnbg_color.connect("clicked", self.on_bg_color_clicked)
		self.btnfont_size.connect("clicked", self.on_size_font_clicked)
		self.btn_super.connect("clicked", self.on_btn_super_clicked)
		self.btn_sub.connect("clicked", self.on_btn_sub_clicked)
		self.btn_tt.connect("clicked", self.on_btn_tt_clicked)	
		self.btn_cite.connect("clicked", self.on_btn_cite_clicked)		
		self.btn_abbr.connect("clicked", self.on_btn_abbr_clicked)	
		self.btn_acron.connect("clicked", self.on_btn_acron_clicked)
	
		self.optwrite_dlg.show_all()
		self.optwrite_dlg.run()
		self.optwrite_dlg.destroy()

	def on_btnMore_clicked(self, widget):
		self.insert_text("<!--more-->")
		try:
			self.optwrite_dlg.destroy()
		except: pass

	def on_btnleft_clicked(self, widget):
		self.wrap_selection('<div style="text-align: left">', '</div>')
		try:
			self.optwrite_dlg.destroy()
		except: pass

	def on_btncenter_clicked(self, widget):
		self.wrap_selection('<div style="text-align: center">', '</div>')
		try:
			self.optwrite_dlg.destroy()
		except: pass

	def on_btnright_clicked(self, widget):
		self.wrap_selection('<div style="text-align: right">', '</div>')
		try:
			self.optwrite_dlg.destroy()
		except: pass

	def on_btnjustify_clicked(self, widget):
		self.wrap_selection('<div style="text-align: justify">', '</div>')
		try:
			self.optwrite_dlg.destroy()
		except: pass

	def on_btnCode_clicked(self, widget):
		self.wrap_selection("<code>","</code>")
		try:
			self.optwrite_dlg.destroy()
		except: pass

	def on_btnUnorderedList_clicked(self, widget):
		self.wrap_selection("<ul>","</ul>")
		try:
			self.optwrite_dlg.destroy()
		except: pass

	def on_btnOrderedList_clicked(self, widget):
		self.wrap_selection("<ol>","</ol>")
		try:
			self.optwrite_dlg.destroy()
		except: pass

	def on_btnListItem_clicked(self, widget):
		self.wrap_selection("<li>","</li>")
		try:
			self.optwrite_dlg.destroy()
		except: pass
		
	def on_text_color_clicked(self, widget):
		try:
			self.optwrite_dlg.destroy()
		except: pass
		#run color selector dialog
		color_selector = hildon.ColorChooserDialog()
		result = color_selector.run() 
		if (result==gtk.RESPONSE_OK):
			#get color selected
			a=gtk.gdk.Color()
			text_color = color_selector.get_color(a)
			#change color selected to a hex string
			colorstring = gtk.color_selection_palette_to_string([a])
			self.wrap_selection('<span style="color:' + colorstring + '">', '</span>')
		color_selector.destroy() 

	def on_bg_color_clicked(self, widget):
		try:
			self.optwrite_dlg.destroy()
		except: pass
		color_selector = hildon.ColorChooserDialog()
		result = color_selector.run() 
		if (result==gtk.RESPONSE_OK):
			a=gtk.gdk.Color()
			bg_color = color_selector.get_color(a) 
			colorstring = gtk.color_selection_palette_to_string([a])
			self.wrap_selection('<span style="background-color:' + colorstring + '">', '</span>')

		color_selector.destroy()

	def on_size_font_clicked(self, widget):
		try:
			self.optwrite_dlg.destroy()
		except: pass
		self.size_font_dlg = gtk.Dialog(title='Font Size', parent=None, flags=gtk.DIALOG_MODAL | gtk.WIN_POS_CENTER, buttons=(gtk.STOCK_OK, gtk.RESPONSE_OK, gtk.STOCK_CANCEL, gtk.RESPONSE_CANCEL))

		self.font_size_list = gtk.ListStore(gobject.TYPE_STRING)
		self.font_size = gtk.ComboBoxEntry(self.font_size_list, 0)		
		list_font_size = ["xx-small", "x-small", "small", "medium", "large", "x-large", "xx-large"]
		for item in list_font_size:
			self.font_size_list.append((item,))

		self.size_font_dlg.vbox.pack_start(self.font_size, False, False, 0)
		self.size_font_dlg.show_all()

		result = self.size_font_dlg.run() 
		if (result==gtk.RESPONSE_OK):
			fontsize = self.font_size.get_active_text()
			self.wrap_selection('<span style="font-size:' + fontsize + '">', '</span>')

		self.size_font_dlg.destroy() 

	def on_btn_super_clicked(self, widget):
		self.wrap_selection("<sup>","</sup>")
		try:
			self.optwrite_dlg.destroy()
		except: pass
		
	def on_btn_sub_clicked(self, widget):
		self.wrap_selection("<sub>","</sub>")
		try:
			self.optwrite_dlg.destroy()
		except: pass		

	def on_btn_tt_clicked(self, widget):
		self.wrap_selection("<tt>","</tt>")
		try:
			self.optwrite_dlg.destroy()
		except: pass

	def on_btn_cite_clicked(self, widget):
		self.wrap_selection("<cite>","</cite>")
		try:
			self.optwrite_dlg.destroy()
		except: pass
		
	def on_btn_abbr_clicked(self, widget):
		try:
			self.optwrite_dlg.destroy()
		except: pass

		self.wTree=gtk.glade.XML(glade_file)
		abbr_dlg = self.wTree.get_widget("main_dialog")
		abbr_dlg.set_title("Insert Abbreviation")
		abbr_dlg.set_default_response(gtk.RESPONSE_CANCEL)
	
		abbr_entry = self.wTree.get_widget("main_entry")
		abbr_label = self.wTree.get_widget("main_label")
		abbr_label.set_text("Enter abbreviation:")
		
		def on_ok_clicked(widget):
			self.wrap_selection('<abbr title="%s">' % abbr_entry.get_text(),"</abbr>")
			
		def on_cancel_clicked(widget):
			abbr_dlg.destroy()
		
		cancel_btn = self.wTree.get_widget("cancelbtn")
		cancel_btn.connect("clicked", on_cancel_clicked)
		ok_btn = self.wTree.get_widget("okbtn")
		ok_btn.connect("clicked", on_ok_clicked)	
			
		result = abbr_dlg.run()
		abbr_dlg.destroy()
		

	def on_btn_acron_clicked(self, widget):
		try:
			self.optwrite_dlg.destroy()
		except: pass
			
		self.wTree=gtk.glade.XML(glade_file)
		acronym_dlg = self.wTree.get_widget("main_dialog")
		acronym_dlg.set_title("Insert Acronym")
		acronym_dlg.set_default_response(gtk.RESPONSE_CANCEL)
	
		acronym_entry = self.wTree.get_widget("main_entry")
		acronym_label = self.wTree.get_widget("main_label")
		acronym_label.set_text("Enter the acronym name:")
		
		def on_ok_clicked(widget):
			self.wrap_selection('<acronym title="%s">' % acronym_entry.get_text(),"</acronym>")
			
		def on_cancel_clicked(widget):
			acronym_dlg.destroy()
		
		cancel_btn = self.wTree.get_widget("cancelbtn")
		cancel_btn.connect("clicked", on_cancel_clicked)
		ok_btn = self.wTree.get_widget("okbtn")
		ok_btn.connect("clicked", on_ok_clicked)	
			
		result = acronym_dlg.run()
		acronym_dlg.destroy()
		

	def on_btnSettings_clicked(self, widget):
		"""Called when the settings button is clicked.  It will
		show the dlgSettings dialog and let the user set the WordPress
		blog settings."""
		self.wTree=gtk.glade.XML(glade_file)
		settings_dlg = self.wTree.get_widget("settings_dlg")
		#osso_hlp.dialog_help_enable(settings_dlg, "help_maemowordpy_settings")
		settings_dlg.set_title("Preferences")
		settings_dlg.set_default_response(gtk.RESPONSE_CANCEL)
	
		self.enURL = self.wTree.get_widget("en_url")
		self.enURL.set_text(self.BlogSettings.URL)
		self.enUsername = self.wTree.get_widget("en_username")
		self.enUsername.set_text(self.BlogSettings.Username)
		self.enPassword = self.wTree.get_widget("en_password")
		self.enPassword.set_text(self.BlogSettings.Password)

		def on_ok_clicked(widget):
			self.BlogSettings.URL = self.enURL.get_text()
			self.BlogSettings.Username = self.enUsername.get_text()
			self.BlogSettings.Password = self.enPassword.get_text()
			
		def on_cancel_clicked(widget):
			settings_dlg.destroy()
		
		cancel_btn = self.wTree.get_widget("sett_can")
		cancel_btn.connect("clicked", on_cancel_clicked)
		ok_btn = self.wTree.get_widget("sett_ok")
		ok_btn.connect("clicked", on_ok_clicked)	
			
		result = settings_dlg.run()
		settings_dlg.destroy()

	def on_btncategories_clicked(self, widget):
		banner = hildon.hildon_banner_show_animation(widget, 'qgn_indi_pball_a', 'Getting categories...')
		thread.start_new_thread(self.trat_categories, (widget, banner))
		
	def trat_categories(self, widget, banner):
		result = gtk.RESPONSE_CANCEL

        # create dialog, etc		
		categories_dlg = gtk.Dialog(title='Select Categories', parent=None, flags=gtk.DIALOG_MODAL | gtk.WIN_POS_CENTER, buttons=(gtk.STOCK_OK, gtk.RESPONSE_OK, gtk.STOCK_CANCEL, gtk.RESPONSE_CANCEL))

		categories_dlg.set_border_width(8)
		categories_dlg.set_default_size(300, 250)

		vbox1 = gtk.VBox(False, 8)

		sw = gtk.ScrolledWindow()
		sw.set_shadow_type(gtk.SHADOW_ETCHED_IN)
		sw.set_policy(gtk.POLICY_NEVER, gtk.POLICY_AUTOMATIC)
		vbox1.pack_start(sw)

		# clear categories chosen before
		del cats[:]
		del data[:]
		
		self.GetCategoryList(banner)	


		if data == []:
			return
		model = self.__create_model()

        # create tree view
		treeview = gtk.TreeView(model)
		treeview.set_rules_hint(True)
		#treeview.set_property("allow-checkbox-mode", False)
		treeview.set_search_column(COLUMN_DESCRIPTION)

		sw.add(treeview)

        # add columns to the tree view
		self.__add_columns(treeview)

		categories_dlg.vbox.pack_start(vbox1, True, True, 0)
		categories_dlg.show_all()
		
		banner.destroy()
		
		gtk.gdk.threads_enter()
		result = categories_dlg.run()
		gtk.gdk.threads_leave()
		
		if (result==gtk.RESPONSE_OK):
			cats2 = cats
			print 'categories added: ', cats2
			gtk.gdk.threads_enter()
			categories_dlg.destroy()
			gtk.gdk.threads_leave()
			
		gtk.gdk.threads_enter()
		categories_dlg.destroy()
		gtk.gdk.threads_leave()
		
		return result


	def GetCategoryList(self, banner):
		#Try to get the wordpress client
		try:
			wp = self.BlogSettings.create_wordpress_client()
			#Select blog. TODO: choose if there is more than one blog
			wp.selectBlog(0)
			categories = tuple(wp.getCategoryList())
			#Save category list in [data]
			for i in categories:
				a = False
				b = i.name
				c = (a, b)
				data.append(c)
		except: 
			banner.destroy()
			gtk.gdk.threads_enter()
			self.show_error_dlg("Error creating Wordpress client, please check settings.")
			gtk.gdk.threads_leave()

	def __create_model(self):
		lstore = gtk.ListStore(gobject.TYPE_BOOLEAN, gobject.TYPE_STRING)
		#Added the category list to lstore
		for item in data:
			iter = lstore.append()
			lstore.set(iter, COLUMN_FIXED, item[COLUMN_FIXED], COLUMN_DESCRIPTION, item[COLUMN_DESCRIPTION])
		return lstore

	def fixed_toggled(self, cell, path, model):
        # get toggled iter
		iter = model.get_iter((int(path),))
		fixed = model.get_value(iter, COLUMN_FIXED)
        # do something with the value
		fixed = not fixed
        # set new value
		model.set(iter, COLUMN_FIXED, fixed)

		#If togglebutton is choose, add category name
		#to [cats]
		if fixed == True:
			a = model.get_value(iter, COLUMN_DESCRIPTION)
			cats.append(a)
		#If togglebutton is choose and delete,
		#delete category name from [cats]
		elif fixed == False:
			b = model.get_value(iter, COLUMN_DESCRIPTION)
#			print 'delete cat: ', b
			numero = cats.index(b)
#			print 'cat index: ', numero
			del cats[numero]

	def __add_columns(self, treeview):
		model = treeview.get_model()

        # column for fixed toggles
		renderer = gtk.CellRendererToggle()
		renderer.connect('toggled', self.fixed_toggled, model)

		column = gtk.TreeViewColumn('Fixed', renderer, active=COLUMN_FIXED)
        # set this column to a fixed sizing(of 50 pixels)
		column.set_sizing(gtk.TREE_VIEW_COLUMN_FIXED)
		column.set_fixed_width(50)
		treeview.append_column(column)

        # column for description
		column = gtk.TreeViewColumn('Description', gtk.CellRendererText(), text=COLUMN_DESCRIPTION)
		treeview.append_column(column)


	def on_btngetarticles_clicked(self, widget):	
		banner = hildon.hildon_banner_show_animation(widget, 'qgn_indi_pball_a', 'Getting articles...')
		thread.start_new_thread(self.trat_articles, (widget, banner))
		
	def trat_articles(self, widget, banner):
		result = gtk.RESPONSE_CANCEL
		
		articles_dlg = gtk.Dialog(title='Delete Articles', parent=None, flags=gtk.DIALOG_MODAL | gtk.WIN_POS_CENTER, buttons=(gtk.STOCK_OK, gtk.RESPONSE_OK, gtk.STOCK_CANCEL, gtk.RESPONSE_CANCEL))

		articles_dlg.set_default_size(-1, 250)

		vbox1 = gtk.VBox(False, 8)

		sw = gtk.ScrolledWindow()
		sw.set_shadow_type(gtk.SHADOW_ETCHED_IN)
		sw.set_policy(gtk.POLICY_NEVER, gtk.POLICY_AUTOMATIC)
		vbox1.pack_start(sw)

		# clear articles chosen before
		del del_articles[:]
		del data_articles[:]
		
		self.GetArticlesList(banner)	

		if data_articles == []:
			return
		
		model = self.__articles_model()

		treeview = gtk.TreeView(model)
		treeview.set_rules_hint(True)
		#treeview.set_property("allow-checkbox-mode", False)
		treeview.set_search_column(COLUMN_DESCRIPTION)

		sw.add(treeview)

		self.__add_articles_columns(treeview)

		articles_dlg.vbox.pack_start(vbox1, True, True, 0)
		articles_dlg.show_all()
		banner.destroy()
			
		gtk.gdk.threads_enter()
		result = articles_dlg.run()
		gtk.gdk.threads_leave()
		
		if (result==gtk.RESPONSE_OK):
		
			try:
				wp = self.BlogSettings.create_wordpress_client()
				thread.start_new_thread(self.delete_posts, (wp,))
				gtk.gdk.threads_enter()
				self.pgbar = ProgressBar("Deleting", self.wndMain)
				gtk.gdk.threads_leave()
			except:
				thread.start_new_thread(self.error_post, ("Error deleting article.",))
				
		gtk.gdk.threads_enter()
		articles_dlg.destroy()
		gtk.gdk.threads_leave()
		return result
	
	def delete_posts(self, wp):
		try:
			for i in del_articles:
				wp.deletePost(i)
			self.pgbar.stop_pg()
			thread.start_new_thread(self.success_dlg, ("Success! Articles deleted.",))
		except:
			thread.start_new_thread(self.error_post, ("Error deleting articles.",))

				
	def GetArticlesList(self, banner):
		try:
			wp = self.BlogSettings.create_wordpress_client()
			wp.selectBlog(0)
			articles = wp.getRecentPosts(5)	
			for i in articles:
				a = False
				b = i.title
				c = i.id
				d = (a, b, c)
				data_articles.append(d)
		except: 
			banner.destroy()
			gtk.gdk.threads_enter()
			self.show_error_dlg("Error creating Wordpress client, please check settings.")
			gtk.gdk.threads_leave()

	def __articles_model(self):
		lstore = gtk.ListStore(gobject.TYPE_BOOLEAN, gobject.TYPE_STRING, gobject.TYPE_STRING)

		for item in data_articles:
			iter = lstore.append()
			lstore.set(iter, COLUMN_ARTICLE_FIXED, item[COLUMN_ARTICLE_FIXED], COLUMN_ARTICLE, item[COLUMN_ARTICLE], COLUMN_ID, item[COLUMN_ID])
		return lstore

	def articles_toggled(self, cell, path, model):
		iter = model.get_iter((int(path),))
		fixed = model.get_value(iter, COLUMN_ARTICLE_FIXED)
		fixed = not fixed

		model.set(iter, COLUMN_ARTICLE_FIXED, fixed)


		if fixed == True:
			a = model.get_value(iter, COLUMN_ID)
			del_articles.append(a)

		elif fixed == False:
			b = model.get_value(iter, COLUMN_ID)
#			print 'delete cat: ', b
			numero = del_articles.index(b)
#			print 'cat index: ', numero
			del del_articles[numero]

	def __add_articles_columns(self, treeview):
		model = treeview.get_model()

		renderer = gtk.CellRendererToggle()
		renderer.connect('toggled', self.articles_toggled, model)

		column = gtk.TreeViewColumn('Fixed', renderer, active=COLUMN_ARTICLE_FIXED)
		column.set_sizing(gtk.TREE_VIEW_COLUMN_FIXED)
		column.set_fixed_width(50)
		treeview.append_column(column)

		column = gtk.TreeViewColumn('Description', gtk.CellRendererText(), text=COLUMN_ARTICLE)
		treeview.append_column(column)
		
		column = gtk.TreeViewColumn('Id', gtk.CellRendererText(), text=COLUMN_ID)
		treeview.append_column(column)
		

	def technorati_tags(self):
		"""Get the technorati tags."""
		#Get tags from text entry
		tags = self.en_tags.get_text()
		#Separate the tags in a list
		tagsArray = []
		for item in tags.split(";"):
			tagsArray.append(item)
		#Create the technorati tag model
		lista = []
		for tag in tagsArray:
			llave = '<a href="http://technorati.com/tag/' + tag + '" rel="tag">' + tag + '</a>'
			lista.append(llave)
		#Separate each link
		self.texto_technorati = (', ').join(lista)


	def on_btnpost_clicked(self, widget):
		#Try to get the wordpress client
		wp = self.BlogSettings.create_wordpress_client()
		if (wp == None):
			#Error creating Client, setting maybe wrong
			self.show_error_dlg("Error creating Wordpress client, please check settings.")
			#Now get out of here
			return

		if self.enTitle.get_text() == '':
			self.show_error_dlg("You must write a title. See in Advanced Edit tab.")
			return			

		try:
			self.posting = True
			thread.start_new_thread(self.trat_post, (wp,))
			self.pgbar = ProgressBar("Publishing", self.wndMain)
		except:
			self.pgbar.stop_pg()
			thread.start_new_thread(self.error_post, ("Error publishing article.",))


		thread.start_new_thread(self.upload_post, (wp,))

	def trat_post(self, wp):
		self.post = wordpresslib.WordPressPost()

		# Allow Pings
#		if self.ping_button.get_active() == True:
#			post.allowPings = '1'
#		else:
#			post.allowPings = '0'

		# Allow Comments
		if self.comm_button.get_active() == True:
			self.post.allowComments = True
		else:
			self.post.allowComments = 'False'

		#Title
		self.post.title = self.enTitle.get_text()
		#Text
		start, end = self.txtBuffer.get_bounds()
		texto_post = self.txtBuffer.get_text(start, end)
		#Execute technorati tags
		self.technorati_tags()
		#If there aren't tags 
		if self.texto_technorati == '<a href="http://technorati.com/tag/" rel="tag"></a>':
			nuevo_texto = texto_post
		#If there are tags add the links to main post
		else: 
			nuevo_texto = texto_post + '<br /><br />' + '<p style="text-align: right"><small>Technorati Tags: ' + self.texto_technorati + '</small><br /></p>'

		self.post.description = nuevo_texto
		#TextMore
		start, end = self.txtBufferExt.get_bounds()
		self.post.textMore = self.txtBufferExt.get_text(start, end)
		#Excerpt
		start, end = self.txtBufferExc.get_bounds()
		self.post.excerpt = self.txtBufferExc.get_text(start, end)
		#Trackbacks 
		trackbackArray = []
		trackbackURLS = self.en_track.get_text()
		for item in trackbackURLS.split(";"):
			trackbackArray.append(item)

		self.post.trackbacks=trackbackArray
		#Categories
		for i in range(len(cats)):
			mj = wp.getCategoryIdFromName(cats[i])
			idfromcat.append(mj) 

		self.post.categories = idfromcat

		# Get publish/draft post
		if self.pub_button.get_active() == True:
			self.publish = True
		elif self.pub_button.get_active() == False:
			self.publish = False

		self.posting = False

	def upload_post(self, wp):
		"""Called when the post button is clicked, this will
		post the post to the blog."""
		while self.posting:
			time.sleep(0.5)

		#Now post the post!
		try:
			new_post_id = wp.newPost(self.post, self.publish)
			self.pgbar.stop_pg()
			thread.start_new_thread(self.success_dlg, ("Success! Article has been published!", ))
		except xmlrpclib.Fault, e:
			self.pgbar.stop_pg()
			thread.start_new_thread(self.error_post, ("Error publishing article:\nError code: %s\nError Message: %s" % (e.faultCode, e.faultString),))
		except xmlrpclib.ProtocolError, e:
			self.pgbar.stop_pg()
			thread.start_new_thread(self.error_post, ("Error publishing article:\nURL: %s\nError code: %s\nError Message: %s" % (e.url, e.errcode, e.errmsg),))
		except:
			self.pgbar.stop_pg()
			thread.start_new_thread(self.error_post, ("Error publishing article.",))

	def success_dlg(self, msg):
		success_dlg = gtk.MessageDialog(type=gtk.MESSAGE_INFO, message_format=msg, buttons=gtk.BUTTONS_CLOSE)
		success_dlg.set_modal(True)
		gtk.gdk.threads_enter()
		success_dlg.run()
		gtk.gdk.threads_leave()
		success_dlg.destroy()
		return True

	def error_post(self, msg):
		error_post_dlg = gtk.MessageDialog(type=gtk.MESSAGE_ERROR, message_format=msg, buttons=gtk.BUTTONS_CLOSE)
		error_post_dlg.set_modal(True)
		gtk.gdk.threads_enter()
		error_post_dlg.run()
		gtk.gdk.threads_leave()
		error_post_dlg.destroy()
		return True


	def browse_for_image(self, widget):
		"""This function is used to browse for an image.
		The path to the image will be returned if the user
		selects one, however a blank string will be returned
		if they cancel or do not select one."""
		self.fileopen_dlg = hildon.FileChooserDialog(self.wndMain, gtk.FILE_CHOOSER_ACTION_OPEN)
		self.fileopen_dlg.set_title("Browse Image")
		self.fileopen_dlg.set_transient_for(self.image_dlg)
		self.fileopen_dlg.set_current_folder('/home/user/MyDocs/.images')

		self.fileopen_dlg.set_default_response(gtk.RESPONSE_OK)
		"""Init the return value"""
		result = ""
		if self.fileopen_dlg.run() == gtk.RESPONSE_OK:
			result = self.fileopen_dlg.get_filename()
			self.currimg_pixbuf_original = gtk.gdk.pixbuf_new_from_file(result)
			self.img_width.set_value(self.currimg_pixbuf_original.get_width())
			self.img_height.set_value(self.currimg_pixbuf_original.get_height())
		self.fileopen_dlg.destroy()

		self.en_imgsrc.set_text(result)

		return result

	def get_selection_iters(self):
		"""This function gets the start and end selection
		iters from the text view.  If there is no selection
		the current position of the cursor will be returned.
		Returns - start,end - gtk.TextIter objects"""

		#init
		start = None
		end = None

		if self.txtPost.is_focus() == 1:
			self.txtBuffer = self.txtPost.get_buffer()
		elif self.txtPostExt.is_focus() == 1:
			self.txtBuffer = self.txtPostExt.get_buffer()
		elif self.txtPostExc.is_focus() == 1:
			self.txtBuffer = self.txtPostExc.get_buffer()

		#First check to see that the text buffer is valid
		if (not self.txtBuffer):
			self.show_error_dlg("Text buffer not available")
			return start,end

		#Get the selection bounds
		bounds = self.txtBuffer.get_selection_bounds();
		if (bounds):
			#If there is a selection we are done
			start,end = bounds
		else:
			#There is no selection so just get the cursor mark
			cursor_mark = self.txtBuffer.get_insert()
			"""Set start and end to be gtk.TextIter objercts at the
			position of the cursor mark"""
			start = self.txtBuffer.get_iter_at_mark(cursor_mark)
			end = self.txtBuffer.get_iter_at_mark(cursor_mark)

		return start, end

	def insert_text(self, text):
		"""This function inserts text into the text buffer
		self.txtBuffer at the current selection.  If text is
		selected it will be overwritten, otherwise it will simply be
		inserted at the cursor position
		text - The text to be inserted in the buffer
		"""

		if self.txtPost.is_focus() == 1:
			self.txtBuffer = self.txtPost.get_buffer()
		elif self.txtPostExt.is_focus() == 1:
			self.txtBuffer = self.txtPostExt.get_buffer()
		elif self.txtPostExc.is_focus() == 1:
			self.txtBuffer = self.txtPostExc.get_buffer()

		start, end = self.get_selection_iters();

		if ((not start)or(not end)):
			self.show_error_dlg("Error inserting text")
			return;

		#Delete the selected text (start and end will be equal after)
		self.txtBuffer.delete(start,end)
		#Save a mark at the start position since after we insert
		#the text start will be invalid
		start_mark = self.txtBuffer.create_mark(None, start, True)
		#Insert, end will be set to the end insert position
		self.txtBuffer.insert(end,text)
		start = self.txtBuffer.get_iter_at_mark(start_mark)
		#select the text, use end as the first param so that
		#it will be the cursor position
		self.txtBuffer.select_range(end,start)
		#delete the start mark
		self.txtBuffer.delete_mark(start_mark)

	def wrap_selection(self, start_tag, end_tag):
		"""This fucntion is used to wrap the currently selected
		text in the gtk.TextView with start_tag and end_tag. If
		there is no selection start_tag and end_tag will be
		inserted at the cursor position
		start_tag - The text that will go at the start of the
		selection.
		end_tag - The text that will go at the end of the
		selection."""

		if self.txtPost.is_focus() == 1:
			self.txtBuffer = self.txtPost.get_buffer()
		elif self.txtPostExt.is_focus() == 1:
			self.txtBuffer = self.txtPostExt.get_buffer()
		elif self.txtPostExc.is_focus() == 1:
			self.txtBuffer = self.txtPostExc.get_buffer()

		start, end = self.get_selection_iters();
		if ((not start)or(not end)):
			self.show_error_dlg("Error inserting text")
			return;
		#Create a mark at the start and end
		start_mark = self.txtBuffer.create_mark(None,start, True)
		end_mark = self.txtBuffer.create_mark(None, end, False)
		#Insert the start_tag
		self.txtBuffer.insert(start, start_tag)
		#Get the end iter again
		end = self.txtBuffer.get_iter_at_mark(end_mark)
		#Insert the end tag
		self.txtBuffer.insert(end, end_tag)
		#Get the start and end iters
		start = self.txtBuffer.get_iter_at_mark(start_mark)
		end = self.txtBuffer.get_iter_at_mark(end_mark)
		#Select the text
		self.txtBuffer.select_range(end,start)
		#Delete the gtk.TextMark objects
		self.txtBuffer.delete_mark(start_mark)
		self.txtBuffer.delete_mark(end_mark)


class WordPressBlogSettings:
	"""This class holds the necessary wordpress blog settings
	URL - The URL of the blog
	Username - The username posting
	Password - The password for the username
	"""
	def __init__(self, File="", URL="", Username="", Password=""):
		self.URL = URL
		self.Username = Username
		self.Password = Password
		if (File != ""):
			# Load from file
			try:
				file = open(File, 'rb')
				self.URL = cPickle.load(file)
				self.Username = cPickle.load(file)
				self.Password = cPickle.load(file)
				dec_pass=base64.decodestring(self.Password)
				self.Password=dec_pass
				file.close()
			except:
				return

	def save(self, File):
		"""cPickle the information into the file"""
		try:
			save_file = open(File, 'wb')
			cPickle.dump(self.URL, save_file)
			cPickle.dump(self.Username, save_file)
			enc_pass=base64.encodestring(self.Password)
			self.Password=enc_pass
			cPickle.dump(self.Password, save_file)
			save_file.close()
		except:
			print "Error saving blog settings."

	def create_wordpress_client(self):
		"""Quick helper routine used to create the wordpress
		client"""
		# prepare client object
		try:
			wp = wordpresslib.WordPressClient(self.URL, self.Username, self.Password)
		except:
			return None

		# select blog id
		wp.selectBlog(0)

		return wp


	def xml_save(self, xml_document):
		"""Save the current blog post to an xml document.
		@param xml_document - xml.dom.minidom.Document object -
		The xml document that we will save the post to."""

		#First create the "settings" xml element
		settings_element = xml_document.createElement(Wordpy._xml_tags[SETTINGS_TAG])
		#Creates <URL></URL>
		URL_element = xml_document.createElement(Wordpy._xml_tags[URL_TAG])
		#Create <URL>URL</URL>
		URL_element.appendChild(xml_document.createTextNode(self.URL))
		#Creates <Username></Username>
		username_element = xml_document.createElement(Wordpy._xml_tags[USERNAME_TAG])
		#Creates <Username>Username</Username>
		username_element.appendChild(xml_document.createTextNode(self.Username))
		#Creates <Password></Password>
		password_element = xml_document.createElement(Wordpy._xml_tags[PASSWORD_TAG])
		#Creates <Password>Password</Password>
		password_element.appendChild(xml_document.createTextNode(self.Password))
		"""Now create:
		<post>
			<URL>URL</URL>
			<Username>Username</Username>
			<Password>Password</Password>
		</post>
		"""
		settings_element.appendChild(URL_element)
		settings_element.appendChild(username_element)
		settings_element.appendChild(password_element)
		#Now add to the xml docuemnt
		xml_document.documentElement.appendChild(settings_element)

	def xml_load(self, xml_document):
		"""Load the current blog post from an xml document.
		@param xml_document - xml.dom.minidom.Document object -
		The xml document that we will load the post from.
		@returns boolean True - success.  False - Failure."""

		URL_loaded = False
		username_loaded = False
		password_loaded = False

		#Loop through all child nodes of the root.
		for node in xml_document.documentElement.childNodes:
			#We are looking for the post Node
			if (node.nodeName == Wordpy._xml_tags[SETTINGS_TAG]):
				# Now loop through the post nodes children
				for item_node in node.childNodes:
					if (item_node.nodeName == Wordpy._xml_tags[URL_TAG]):
						"""Set the URL"""
						#Make sure it's not a blank string
						if (item_node.firstChild):
							self.URL = item_node.firstChild.nodeValue
						else:
							self.URL = ""
						URL_loaded = True
					elif (item_node.nodeName == Wordpy._xml_tags[USERNAME_TAG]):
						"""Set the username"""
						#Make sure it's not a blank string
						if (item_node.firstChild):
							self.Username = item_node.firstChild.nodeValue
						else:
							self.Username = ""
						username_loaded = True
					elif (item_node.nodeName == Wordpy._xml_tags[PASSWORD_TAG]):
						"""Set the pasword"""
						#Make sure it's not a blank string
						if (item_node.firstChild):
							self.Password = item_node.firstChild.nodeValue
						else:
							self.Password = ""
						password_loaded = True
			#Break out of the topmost for loop
			break

		return (URL_loaded and username_loaded and password_loaded)

class ProgressBar:
	def __init__(self, pg_text, window):
		self.w = gtk.Dialog("Progressbar", None)
		self.w.set_transient_for(window)
		vbox = gtk.VBox(False, 5)
		self.progress = gtk.ProgressBar()
		self.progress.set_size_request(250,-1)
		self.progress.set_text(pg_text)
		vbox.add(self.progress)
		self.w.vbox.add(vbox)
		self.w.show_all()

		self.active = True
		self.progress.pulse()
		self.timeout_cb = gobject.timeout_add(200, self.increment)

	def stop_pg(self):
		self.active = False
		self.w.destroy()

	def increment(self):        
		if not self.active:
            # we were disabled, so stop pulsating
			return False
		self.progress.pulse()
		return True
		

if __name__ == "__main__":
	app = Wordpy()
	gtk.gdk.threads_enter()
	gtk.main()
	gtk.gdk.threads_leave()
